Version bump.
authorRobin H. Johnson <robbat2@gentoo.org>
Thu, 25 Aug 2011 01:45:36 +0000 (01:45 +0000)
committerRobin H. Johnson <robbat2@gentoo.org>
Thu, 25 Aug 2011 01:45:36 +0000 (01:45 +0000)
Package-Manager: portage-2.2.0_alpha51/cvs/Linux x86_64

dev-vcs/git/ChangeLog
dev-vcs/git/Manifest
dev-vcs/git/git-1.7.6.1.ebuild [new file with mode: 0644]

index 7ebeabaaeacf21f9daf30decd1af01f69c8360ed..784541166d0a3a41b02450192242a83bbf988e04 100644 (file)
@@ -1,6 +1,11 @@
 # ChangeLog for dev-vcs/git
 # Copyright 1999-2011 Gentoo Foundation; Distributed under the GPL v2
-# $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/ChangeLog,v 1.98 2011/08/19 18:43:47 darkside Exp $
+# $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/ChangeLog,v 1.99 2011/08/25 01:45:36 robbat2 Exp $
+
+*git-1.7.6.1 (25 Aug 2011)
+
+  25 Aug 2011; Robin H. Johnson <robbat2@gentoo.org> +git-1.7.6.1.ebuild:
+  Version bump.
 
   19 Aug 2011; Jeremy Olexa <darkside@gentoo.org> git-1.7.2.5.ebuild,
   git-1.7.3.4-r1.ebuild, git-1.7.3.5.ebuild, git-1.7.3.5-r1.ebuild,
index 5af2ca81618f8daae077c95fd779176b62bbc9d6..8885c5d2e0794cfb0c3108ddf319babdeeaed7fa 100644 (file)
@@ -22,6 +22,7 @@ DIST git-1.7.4.tar.bz2 2703735 RMD160 a064d7a5b2d3fae6171ca91a03082eb46d7bb9b7 S
 DIST git-1.7.5.3.tar.bz2 2766856 RMD160 99a8f69690dc75c37b5141c6984dc5b499fcd8d4 SHA1 762d0985af37c9dda4e22c84e09c6e4efb46a22a SHA256 8017b0c624fea88bf5488d35f3839778fac3c0e089a02fe0017aea6913af3292
 DIST git-1.7.5.rc1.tar.bz2 2753147 RMD160 cd2f3b6e4bcfc45ea384cab5c62bd28cd11cd2c3 SHA1 0d68a770d363272bc7dbcedfdd2602310379242e SHA256 4424f22f96ee091476d8c260deda55eb333a0af1500d1f63f19f7a0ac2633014
 DIST git-1.7.5.rc3.tar.bz2 2754303 RMD160 d287ab8542fe8dcf14105daf7ccad46912fd625f SHA1 02c9c9b539bba5abac66a8201caedc03d56bfcf2 SHA256 0400002ead965ebed6a2dd252a3abbb33d940f0136a2685a641b81c9cf622754
+DIST git-1.7.6.1.tar.bz2 2811203 RMD160 ec85ee434e51fbb3144b5336921922afc97ba709 SHA1 a0e9f63ec432d4b20411d3759084b4118edf5887 SHA256 856d4197ef7172938b0b44e55174c7d7ddfaf5e844e04960322c49eda9f3a246
 DIST git-1.7.6.tar.bz2 2806337 RMD160 9ba5daa7bf56b6a242b3302e12c8ced7d3abc77a SHA1 c519b0765c419c84b561bb4a2a86526b16d95cde SHA256 778795cece63cd758192378f3a999870cea290181b3a4c9de573c77192561082
 DIST git-htmldocs-1.6.4.5.tar.bz2 772113 RMD160 64b3f689385334d9b101b4bb8647f0fed14bd1fc SHA1 4ac2ede0a3ed82dea9107ff5e4a4948b60282f49 SHA256 12c13ead869918d8470d68c7331675c56a192eae819c283a398aaf9f0f7555d2
 DIST git-htmldocs-1.7.2.5.tar.bz2 919247 RMD160 8ff6503efdb3cfaa639d2acbfaf76dad274aeb8f SHA1 b99f4e9eb620918b68fd98a4a0f0686832799477 SHA256 6b6291ffad4eae80d2739acdffffdd6293b9e50366cfa53ffb0c3a1427700337
@@ -34,6 +35,7 @@ DIST git-htmldocs-1.7.4.tar.bz2 940665 RMD160 19a20260259fca5d7898e7661ae2ce9af7
 DIST git-htmldocs-1.7.5.3.tar.bz2 956542 RMD160 777b354e18522bebd4ebfed070179e632998b5da SHA1 f0a66b8b21fab39acf466cea5c14416c718334c4 SHA256 a08cc349b53271cf1b1c23d68033105bee25b1cb1884c8ecaa12271737baff52
 DIST git-htmldocs-1.7.5.rc1.tar.bz2 947839 RMD160 38028acebeb4d8d06f48e41b44c44f1ff8c99bf2 SHA1 03ae74753d1954a71cf2994fa34fd948f918b583 SHA256 960911628dede957f50eefac76328e97514b1d4d8cc52effcac74d4c6a22ddaf
 DIST git-htmldocs-1.7.5.rc3.tar.bz2 948759 RMD160 ced2881bc257f014d35e9315ac805ad341ff8bbb SHA1 d65f6c409d6a87accccf89e9e73465ac92ef74ae SHA256 4096452b503d76b19cc2fc0cc87ba1813e7de2a7e8cb874767dbfeb085a1b013
+DIST git-htmldocs-1.7.6.1.tar.bz2 978820 RMD160 357cda7d4df61db43cafae0c4b3d42bc84f02f13 SHA1 525888fff8242ba03d59de2fdb8afd80310d978a SHA256 6f03a7ed0c2db4d47c22bb27c27249be9bc3c50b72e108d7dca5227917b2de7a
 DIST git-htmldocs-1.7.6.tar.bz2 974583 RMD160 0c396a95126670a67c3e61ea69196508b88ef195 SHA1 926168673669d7568b94af6dec35b9ef10ecaedc SHA256 7e6685c89149d1e1e84a916d913452cfbac3ae801d02a0631243e41c25949277
 DIST git-manpages-1.6.4.5.tar.bz2 254368 RMD160 7731d81631ec2c8c33ddc028667eaad79926754b SHA1 905d5e66db1b22b48c1b001d1f5dec830a75dde1 SHA256 f73ae98b0cea0ef6d8f7c8b599d6cad0bdae702b1fe58ad8ebab32a0bb7ba447
 DIST git-manpages-1.7.2.5.tar.bz2 289543 RMD160 b921fa2b5ec47e091987d1122b1c189b4bd87f3b SHA1 735ee1f23428404bdb99d9b0bd1cbb79c9e7afce SHA256 a42a977a1ecfd3cea62e1f02fc89f57029a94f163ff7205f6a56ab4b67d6bd6e
@@ -46,6 +48,7 @@ DIST git-manpages-1.7.4.tar.bz2 300025 RMD160 ea82117f6150cead06373667054acabbfa
 DIST git-manpages-1.7.5.3.tar.bz2 304065 RMD160 02919cf1db61717f6f3ad298c31d6eae3c01b48a SHA1 2b6f770b0314d12d7abd4fe2274a46c29ac64f50 SHA256 018f5c16b9a3c4e4942ae318d1faea0b6092287228069a718efd267b9f98b8c8
 DIST git-manpages-1.7.5.rc1.tar.bz2 300314 RMD160 d9ec84a4e2c9177ac292f1fe905fcd88d2401a78 SHA1 096e7edc944154ff854abe2fcb48a62a9c1c874a SHA256 72000ccbffa0ddadf90b5e2831ef0b2122c6771e69c4bcfee24003a2d4dd8a5b
 DIST git-manpages-1.7.5.rc3.tar.bz2 300578 RMD160 cc2d1a0f3de158a41ce2174d87b76df5e366b30d SHA1 d386db01edcbc826e82c88f7dcf61956b00b500e SHA256 8a14d4bbca3d0484a30d30e6efb0a697d574eeedb0ca790cebd00523cebedec5
+DIST git-manpages-1.7.6.1.tar.bz2 318418 RMD160 16fdba0c70f0998dd08bf0d1b1b47ba5f1834849 SHA1 e1817c996fc0bf06abd6b15232040de766798101 SHA256 faece1418e72d90ed9ee65e59fe89489e504db9b76e8325a2505e8fb61598a44
 DIST git-manpages-1.7.6.tar.bz2 309563 RMD160 9534cf6540c3be85c6f3b5dfca8ca0cf3f2f366f SHA1 45e0759597d649b13f684f55a186d46dafb7d414 SHA256 a0ffd7e16997262ef741db5e2dd8eabf44b6767cf1a213753c7d8a268b4553ad
 EBUILD git-1.6.4.5.ebuild 10406 RMD160 974979cc54ba06659818d908b6a4fc37a2e463a1 SHA1 f5b78964fcc68509bd32baffef8016c9ad710bcc SHA256 186e72aa90b3c98448a64b7ae718772675a601c80091509b1ccce44c824830e1
 EBUILD git-1.7.2.5.ebuild 13520 RMD160 9411dac852204b7446bcbaddf3c96ac25f3b6028 SHA1 7fcbba3389a5f8dd1fbf2ed228285d4351b4d000 SHA256 666e01293c6884d6ac11578b45f1fdcdf298cdb6d194c249f8e993d6c1b27343
@@ -60,7 +63,8 @@ EBUILD git-1.7.4.ebuild 14671 RMD160 a0e0510d8518ae87e25636ece858c96319b3b350 SH
 EBUILD git-1.7.5.3.ebuild 14734 RMD160 30ee5d07c329cd1dc518e7f41eba2fec33fdf8eb SHA1 bdc52b50209d86f9f673aaad8957c109c23275b4 SHA256 fd9935d807b1ed4d1a9601beba880a2c201e45e8f885197785a3b2941b3b1ace
 EBUILD git-1.7.5_rc1.ebuild 14675 RMD160 50b9e3f9d333a0fd489f3c8f71a1ae3b52c32ec9 SHA1 f1ab39b6eb3aa19444856be7105d5ce59c318551 SHA256 5821eebd1cb76777e46360ffe3f5e50d9395168aeccf183ad045a57bde3fec3e
 EBUILD git-1.7.5_rc3.ebuild 14614 RMD160 10e0308968960bdef92b3022429f9053a6c36073 SHA1 71db896cfe37fe162830bbea00676272d80425e0 SHA256 f9a831d79f1331221e3ebd6fa505cd2bf2c2ec9387858ca68105e1f2452b2169
+EBUILD git-1.7.6.1.ebuild 15021 RMD160 8c7d802ba29c106e972f86bd60784892e04f7a4b SHA1 caf8c2525cdaa6114054d6c7a787aeca8b8022f8 SHA256 4b1d1a6ad20b172b0f4c5bebc0c9b20f50aa01bdf3c911cc67e6c9a32bffef60
 EBUILD git-1.7.6.ebuild 15020 RMD160 4e697a7a87e2969d4cf1638e9d2b5d799681499d SHA1 872d5b71d75a7e450ae629754a250995700c6573 SHA256 3a379c664bbe1e9bdc6e6173bd273950f863770900fd7e8c9cc096f98e97854c
 EBUILD git-9999.ebuild 14913 RMD160 fe9eda7fddd9a8d1fdd0f92cba882d1a1a4e1529 SHA1 5db2b371a1371230790a5c1cc143eababae466dd SHA256 f810f1831c6033fe4f3ea15b6b30576303c849660b397af528f6aefa8b6f28ed
-MISC ChangeLog 82087 RMD160 767b704c6a557d77a9638cdb62bc219a514cda5f SHA1 64c06a8de6fd84f014076f7534431300d6657bfb SHA256 29bbc12cbcd7b6a55b46e0b0b2317a9c8647bb46271dca27b35b199266863fb1
+MISC ChangeLog 82205 RMD160 65b6f594ab19427302646ae0c4bdeaeb88472421 SHA1 0c04a92520042e9c0e2e521117d5f8205a420b06 SHA256 18f9a7274c2ab36238864b0677af7f70ecec4666f39a3695a8bc55b549de1cd6
 MISC metadata.xml 1609 RMD160 80bd2234e48fccd7a442fd6cce3ad9e2f8a05d33 SHA1 0b3b2f486530e009fbe055a87d58a161722f64b1 SHA256 2450bc31e647972be38e76068c6cf27c34e00cd8077f139a137f9d4c14d52a0b
diff --git a/dev-vcs/git/git-1.7.6.1.ebuild b/dev-vcs/git/git-1.7.6.1.ebuild
new file mode 100644 (file)
index 0000000..bdb03da
--- /dev/null
@@ -0,0 +1,520 @@
+# Copyright 1999-2011 Gentoo Foundation
+# Distributed under the terms of the GNU General Public License v2
+# $Header: /var/cvsroot/gentoo-x86/dev-vcs/git/git-1.7.6.1.ebuild,v 1.1 2011/08/25 01:45:36 robbat2 Exp $
+
+EAPI=3
+
+GENTOO_DEPEND_ON_PERL=no
+
+# bug #329479: git-remote-testgit is not multiple-version aware
+PYTHON_DEPEND="python? 2"
+[[ ${PV} == *9999 ]] && SCM="git-2"
+EGIT_REPO_URI="git://git.kernel.org/pub/scm/git/git.git"
+
+inherit toolchain-funcs eutils elisp-common perl-module bash-completion python ${SCM}
+
+MY_PV="${PV/_rc/.rc}"
+MY_P="${PN}-${MY_PV}"
+
+DOC_VER=${MY_PV}
+
+DESCRIPTION="GIT - the stupid content tracker, the revision control system heavily used by the Linux kernel team"
+HOMEPAGE="http://www.git-scm.com/"
+if [[ ${PV} != *9999 ]]; then
+       SRC_URI="mirror://kernel/software/scm/git/${MY_P}.tar.bz2
+                       mirror://kernel/software/scm/git/${PN}-manpages-${DOC_VER}.tar.bz2
+                       doc? ( mirror://kernel/software/scm/git/${PN}-htmldocs-${DOC_VER}.tar.bz2 )"
+       KEYWORDS="~alpha ~amd64 ~arm ~hppa ~ia64 ~mips ~ppc ~ppc64 ~s390 ~sh ~sparc ~x86 ~ppc-aix ~sparc-fbsd ~x86-fbsd ~x64-freebsd ~x86-freebsd ~ia64-hpux ~x86-interix ~amd64-linux ~ia64-linux ~x86-linux ~ppc-macos ~x64-macos ~x86-macos ~sparc-solaris ~sparc64-solaris ~x64-solaris ~x86-solaris"
+else
+       SRC_URI=""
+       KEYWORDS=""
+fi
+
+LICENSE="GPL-2"
+SLOT="0"
+IUSE="+blksha1 +curl cgi doc emacs gtk iconv +perl +python ppcsha1 tk +threads +webdav xinetd cvs subversion"
+
+# Common to both DEPEND and RDEPEND
+CDEPEND="
+       !blksha1? ( dev-libs/openssl )
+       sys-libs/zlib
+       perl?   ( dev-lang/perl[-build] )
+       tk?     ( dev-lang/tk )
+       curl?   (
+               net-misc/curl
+               webdav? ( dev-libs/expat )
+       )
+       emacs?  ( virtual/emacs )"
+
+RDEPEND="${CDEPEND}
+       perl? ( dev-perl/Error
+                       dev-perl/Net-SMTP-SSL
+                       dev-perl/Authen-SASL
+                       cgi? ( virtual/perl-CGI )
+                       cvs? ( >=dev-vcs/cvsps-2.1 dev-perl/DBI dev-perl/DBD-SQLite )
+                       subversion? ( dev-vcs/subversion[-dso,perl] dev-perl/libwww-perl dev-perl/TermReadKey )
+                       )
+       python? ( gtk?
+       (
+               >=dev-python/pygtk-2.8
+               dev-python/pygtksourceview:2
+       ) )"
+
+# This is how info docs are created with Git:
+#   .txt/asciidoc --(asciidoc)---------> .xml/docbook
+#   .xml/docbook  --(docbook2texi.pl)--> .texi
+#   .texi         --(makeinfo)---------> .info
+DEPEND="${CDEPEND}
+       app-arch/cpio
+       doc?    (
+               app-text/asciidoc
+               app-text/docbook2X
+               sys-apps/texinfo
+       )"
+
+# Live ebuild builds man pages and HTML docs, additionally
+if [[ ${PV} == *9999 ]]; then
+       DEPEND="${DEPEND}
+               app-text/asciidoc
+               app-text/xmlto"
+fi
+
+SITEFILE=50${PN}-gentoo.el
+S="${WORKDIR}/${MY_P}"
+
+pkg_setup() {
+       if ! use perl ; then
+               use cgi && ewarn "gitweb needs USE=perl, ignoring USE=cgi"
+               use cvs && ewarn "CVS integration needs USE=perl, ignoring USE=cvs"
+               use subversion && ewarn "git-svn needs USE=perl, it won't work"
+       fi
+       if use webdav && ! use curl ; then
+               ewarn "USE=webdav needs USE=curl. Ignoring"
+       fi
+       if use subversion && has_version dev-vcs/subversion && built_with_use --missing false dev-vcs/subversion dso ; then
+               ewarn "Per Gentoo bugs #223747, #238586, when subversion is built"
+               ewarn "with USE=dso, there may be weird crashes in git-svn. You"
+               ewarn "have been warned."
+       fi
+       if use python ; then
+               python_set_active_version 2
+               python_pkg_setup
+       fi
+}
+
+# This is needed because for some obscure reasons future calls to make don't
+# pick up these exports if we export them in src_unpack()
+exportmakeopts() {
+       local myopts
+
+       if use blksha1 ; then
+               myopts="${myopts} BLK_SHA1=YesPlease"
+       elif use ppcsha1 ; then
+               myopts="${myopts} PPC_SHA1=YesPlease"
+       fi
+
+       if use curl ; then
+               use webdav || myopts="${myopts} NO_EXPAT=YesPlease"
+       else
+               myopts="${myopts} NO_CURL=YesPlease"
+       fi
+
+       # broken assumptions, because of broken build system ...
+       myopts="${myopts} NO_FINK=YesPlease NO_DARWIN_PORTS=YesPlease"
+       myopts="${myopts} INSTALL=install TAR=tar"
+       myopts="${myopts} SHELL_PATH=${EPREFIX}/bin/sh"
+       myopts="${myopts} SANE_TOOL_PATH="
+       myopts="${myopts} OLD_ICONV="
+       myopts="${myopts} NO_EXTERNAL_GREP="
+
+       # can't define this to null, since the entire makefile depends on it
+       sed -i -e '/\/usr\/local/s/BASIC_/#BASIC_/' Makefile
+
+       use iconv \
+               || einfo "Forcing iconv for ${PVR} due to bugs #321895, #322205."
+       #       || myopts="${myopts} NO_ICONV=YesPlease"
+       # because, above, we need to do this unconditionally (no "&& use iconv")
+       use !elibc_glibc && myopts="${myopts} NEEDS_LIBICONV=YesPlease"
+
+       use tk \
+               || myopts="${myopts} NO_TCLTK=YesPlease"
+       use perl \
+               && myopts="${myopts} INSTALLDIRS=vendor" \
+               || myopts="${myopts} NO_PERL=YesPlease"
+       use python \
+               || myopts="${myopts} NO_PYTHON=YesPlease"
+       use subversion \
+               || myopts="${myopts} NO_SVN_TESTS=YesPlease"
+       use threads \
+               && myopts="${myopts} THREADED_DELTA_SEARCH=YesPlease"
+       use cvs \
+               || myopts="${myopts} NO_CVS=YesPlease"
+# Disabled until ~m68k-mint can be keyworded again
+#      if [[ ${CHOST} == *-mint* ]] ; then
+#              myopts="${myopts} NO_MMAP=YesPlease"
+#              myopts="${myopts} NO_IPV6=YesPlease"
+#              myopts="${myopts} NO_STRLCPY=YesPlease"
+#              myopts="${myopts} NO_MEMMEM=YesPlease"
+#              myopts="${myopts} NO_MKDTEMP=YesPlease"
+#              myopts="${myopts} NO_MKSTEMPS=YesPlease"
+#      fi
+       if [[ ${CHOST} == ia64-*-hpux* ]]; then
+               myopts="${myopts} NO_NSEC=YesPlease"
+       fi
+       if [[ ${CHOST} == *-*-aix* ]]; then
+               myopts="${myopts} NO_FNMATCH_CASEFOLD=YesPlease"
+       fi
+
+       has_version '>=app-text/asciidoc-8.0' \
+               && myopts="${myopts} ASCIIDOC8=YesPlease"
+       myopts="${myopts} ASCIIDOC_NO_ROFF=YesPlease"
+
+       # Bug 290465:
+       # builtin-fetch-pack.c:816: error: 'struct stat' has no member named 'st_mtim'
+       [[ "${CHOST}" == *-uclibc* ]] && \
+               myopts="${myopts} NO_NSEC=YesPlease"
+
+       export MY_MAKEOPTS="${myopts}"
+}
+
+src_unpack() {
+       if [[ ${PV} != *9999 ]]; then
+               unpack ${MY_P}.tar.bz2
+               cd "${S}"
+               unpack ${PN}-manpages-${DOC_VER}.tar.bz2
+               use doc && \
+                       cd "${S}"/Documentation && \
+                       unpack ${PN}-htmldocs-${DOC_VER}.tar.bz2
+               cd "${S}"
+       else
+               git-2_src_unpack
+               cd "${S}"
+               #cp "${FILESDIR}"/GIT-VERSION-GEN .
+       fi
+
+}
+
+src_prepare() {
+       # Noperl is being merged to upstream as of 2009/04/05
+       #epatch "${FILESDIR}"/20090305-git-1.6.2-noperl.patch
+
+       # GetOpt-Long v2.38 is strict
+       # Merged in 1.6.3 final 2009/05/07
+       #epatch "${FILESDIR}"/20090505-git-1.6.2.5-getopt-fixes.patch
+
+       # JS install fixup
+       # Merged in 1.7.5.x
+       #epatch "${FILESDIR}"/git-1.7.2-always-install-js.patch
+
+       # USE=-iconv causes segfaults, fixed post 1.7.1
+       # Gentoo bug #321895
+       #epatch "${FILESDIR}"/git-1.7.1-noiconv-segfault-fix.patch
+
+       # Fix false positives with t3404 due to SHELL=/bin/false for the portage
+       # user.
+       # Merged upstream
+       #epatch "${FILESDIR}"/git-1.7.3.4-avoid-shell-issues.patch
+
+       # bug #350075: t9001: fix missing prereq on some tests
+       # Merged upstream
+       #epatch "${FILESDIR}"/git-1.7.3.4-fix-perl-test-prereq.patch
+
+       # bug #350330 - automagic CVS when we don't want it is bad.
+       epatch "${FILESDIR}"/git-1.7.3.5-optional-cvs.patch
+
+       sed -i \
+               -e 's:^\(CFLAGS =\).*$:\1 $(OPTCFLAGS) -Wall:' \
+               -e 's:^\(LDFLAGS =\).*$:\1 $(OPTLDFLAGS):' \
+               -e 's:^\(CC = \).*$:\1$(OPTCC):' \
+               -e 's:^\(AR = \).*$:\1$(OPTAR):' \
+               -e "s:\(PYTHON_PATH = \)\(.*\)$:\1${EPREFIX}\2:" \
+               -e "s:\(PERL_PATH = \)\(.*\)$:\1${EPREFIX}\2:" \
+               Makefile || die "sed failed"
+
+       # Never install the private copy of Error.pm (bug #296310)
+       sed -i \
+               -e '/private-Error.pm/s,^,#,' \
+               perl/Makefile.PL
+
+       # Fix docbook2texi command
+       sed -i 's/DOCBOOK2X_TEXI=docbook2x-texi/DOCBOOK2X_TEXI=docbook2texi.pl/' \
+               Documentation/Makefile || die "sed failed"
+
+       # bug #318289
+       # Merged upstream
+       #epatch "${FILESDIR}"/git-1.7.3.2-interix.patch
+
+       # merged upstream
+       #epatch "${FILESDIR}"/git-1.7.5-interix.patch
+       # but only one of two hunks made it into the release ... :(
+       epatch "${FILESDIR}"/git-1.7.6-interix.patch
+}
+
+git_emake() {
+       # bug #326625: PERL_PATH, PERL_MM_OPT
+       # bug #320647: PYTHON_PATH
+       PYTHON_PATH=""
+       use python && PYTHON_PATH="$(PYTHON -a)"
+       emake ${MY_MAKEOPTS} \
+               DESTDIR="${D}" \
+               OPTCFLAGS="${CFLAGS}" \
+               OPTLDFLAGS="${LDFLAGS}" \
+               OPTCC="$(tc-getCC)" \
+               OPTAR="$(tc-getAR)" \
+               prefix="${EPREFIX}"/usr \
+               htmldir="${EPREFIX}"/usr/share/doc/${PF}/html \
+               sysconfdir="${EPREFIX}"/etc \
+               PYTHON_PATH="${PYTHON_PATH}" \
+               PERL_MM_OPT="" \
+               GIT_TEST_OPTS="--no-color" \
+               "$@"
+       # This is the fix for bug #326625, but it also causes breakage, see bug
+       # #352693.
+       # PERL_PATH="${EPREFIX}/usr/bin/env perl" \
+}
+
+src_configure() {
+       exportmakeopts
+}
+
+src_compile() {
+       git_emake || die "emake failed"
+
+       if use emacs ; then
+               elisp-compile contrib/emacs/git{,-blame}.el \
+                       || die "emacs modules failed"
+       fi
+
+       if use perl && use cgi ; then
+               git_emake \
+                       gitweb/gitweb.cgi \
+                       || die "emake gitweb/gitweb.cgi failed"
+       fi
+
+       cd "${S}"/Documentation
+       if [[ ${PV} == *9999 ]] ; then
+               git_emake man \
+                       || die "emake man failed"
+               if use doc ; then
+                       git_emake info html \
+                               || die "emake info html failed"
+               fi
+       else
+               if use doc ; then
+                       git_emake info \
+                               || die "emake info html failed"
+               fi
+       fi
+}
+
+src_install() {
+       git_emake \
+               install || \
+               die "make install failed"
+
+       # Depending on the tarball and manual rebuild of the documentation, the
+       # manpages may exist in either OR both of these directories.
+       find man?/*.[157] >/dev/null 2>&1 && doman man?/*.[157]
+       find Documentation/*.[157] >/dev/null 2>&1 && doman Documentation/*.[157]
+
+       dodoc README Documentation/{SubmittingPatches,CodingGuidelines}
+       use doc && dodir /usr/share/doc/${PF}/html
+       for d in / /howto/ /technical/ ; do
+               docinto ${d}
+               dodoc Documentation${d}*.txt
+               use doc && dohtml -p ${d} Documentation${d}*.html
+       done
+       docinto /
+       # Upstream does not ship this pre-built :-(
+       use doc && doinfo Documentation/{git,gitman}.info
+
+       dobashcompletion contrib/completion/git-completion.bash ${PN}
+
+       if use emacs ; then
+               elisp-install ${PN} contrib/emacs/git.{el,elc} || die
+               elisp-install ${PN} contrib/emacs/git-blame.{el,elc} || die
+               #elisp-install ${PN}/compat contrib/emacs/vc-git.{el,elc} || die
+               # don't add automatically to the load-path, so the sitefile
+               # can do a conditional loading
+               touch "${ED}${SITELISP}/${PN}/compat/.nosearch"
+               elisp-site-file-install "${FILESDIR}"/${SITEFILE} || die
+       fi
+
+       if use python && use gtk ; then
+               dobin "${S}"/contrib/gitview/gitview
+               python_convert_shebangs ${PYTHON_ABI} "${ED}"/usr/bin/gitview
+               dodoc "${S}"/contrib/gitview/gitview.txt
+       fi
+
+       dobin contrib/fast-import/git-p4
+       dodoc contrib/fast-import/git-p4.txt
+       newbin contrib/fast-import/import-tars.perl import-tars
+       newbin contrib/git-resurrect.sh git-resurrect
+
+       dodir /usr/share/${PN}/contrib
+       # The following are excluded:
+       # completion - installed above
+       # emacs - installed above
+       # examples - these are stuff that is not used in Git anymore actually
+       # gitview - installed above
+       # p4import - excluded because fast-import has a better one
+       # patches - stuff the Git guys made to go upstream to other places
+       # svnimport - use git-svn
+       # thunderbird-patch-inline - fixes thunderbird
+       for i in \
+               blameview buildsystems ciabot continuous convert-objects fast-import \
+               hg-to-git hooks remotes2config.sh remotes2config.sh rerere-train.sh \
+               stats svn-fe vim workdir \
+               ; do
+               cp -rf \
+                       "${S}"/contrib/${i} \
+                       "${ED}"/usr/share/${PN}/contrib \
+                       || die "Failed contrib ${i}"
+       done
+
+       if use perl && use cgi ; then
+               # We used to install in /usr/share/${PN}/gitweb
+               # but upstream installs in /usr/share/gitweb
+               # so we will install a symlink and use their location for compat with other
+               # distros
+               dosym /usr/share/gitweb /usr/share/${PN}/gitweb
+
+               # INSTALL discusses configuration issues, not just installation
+               docinto /
+               newdoc  "${S}"/gitweb/INSTALL INSTALL.gitweb
+               newdoc  "${S}"/gitweb/README README.gitweb
+
+               find "${ED}"/usr/lib64/perl5/ \
+                       -name .packlist \
+                       -exec rm \{\} \;
+       else
+               rm -rf "${ED}"/usr/share/gitweb
+       fi
+
+       if ! use subversion ; then
+               rm -f "${ED}"/usr/libexec/git-core/git-svn \
+                       "${ED}"/usr/share/man/man1/git-svn.1*
+       fi
+
+       if use xinetd ; then
+               insinto /etc/xinetd.d
+               newins "${FILESDIR}"/git-daemon.xinetd git-daemon
+       fi
+
+       newinitd "${FILESDIR}"/git-daemon.initd git-daemon
+       newconfd "${FILESDIR}"/git-daemon.confd git-daemon
+
+       fixlocalpod
+}
+
+src_test() {
+       local disabled=""
+       local tests_cvs="t9200-git-cvsexportcommit.sh \
+                                       t9400-git-cvsserver-server.sh \
+                                       t9401-git-cvsserver-crlf.sh \
+                                       t9600-cvsimport.sh \
+                                       t9601-cvsimport-vendor-branch.sh \
+                                       t9602-cvsimport-branches-tags.sh \
+                                       t9603-cvsimport-patchsets.sh"
+       local tests_perl="t5502-quickfetch.sh \
+                                       t5512-ls-remote.sh \
+                                       t5520-pull.sh"
+       # Bug #225601 - t0004 is not suitable for root perm
+       # Bug #219839 - t1004 is not suitable for root perm
+       # t0001-init.sh - check for init notices EPERM*  fails
+       local tests_nonroot="t0001-init.sh \
+               t0004-unwritable.sh \
+               t0070-fundamental.sh \
+               t1004-read-tree-m-u-wf.sh \
+               t3700-add.sh \
+               t7300-clean.sh"
+
+       # Unzip is used only for the testcase code, not by any normal parts of Git.
+       if ! has_version app-arch/unzip ; then
+               einfo "Disabling tar-tree tests"
+               disabled="${disabled} t5000-tar-tree.sh"
+       fi
+
+       cvs=0
+       use cvs && let cvs=$cvs+1
+       if [[ ${EUID} -eq 0 ]]; then
+               if [[ $cvs -eq 1 ]]; then
+                       ewarn "Skipping CVS tests because CVS does not work as root!"
+                       ewarn "You should retest with FEATURES=userpriv!"
+                       disabled="${disabled} ${tests_cvs}"
+               fi
+               einfo "Skipping other tests that require being non-root"
+               disabled="${disabled} ${tests_nonroot}"
+       else
+               [[ $cvs -gt 0 ]] && \
+                       has_version dev-vcs/cvs && \
+                       let cvs=$cvs+1
+               [[ $cvs -gt 1 ]] && \
+                       built_with_use dev-vcs/cvs server && \
+                       let cvs=$cvs+1
+               if [[ $cvs -lt 3 ]]; then
+                       einfo "Disabling CVS tests (needs dev-vcs/cvs[USE=server])"
+                       disabled="${disabled} ${tests_cvs}"
+               fi
+       fi
+
+       if ! use perl ; then
+               einfo "Disabling tests that need Perl"
+               disabled="${disabled} ${tests_perl}"
+       fi
+
+       # Reset all previously disabled tests
+       cd "${S}/t"
+       for i in *.sh.DISABLED ; do
+               [[ -f "${i}" ]] && mv -f "${i}" "${i%.DISABLED}"
+       done
+       einfo "Disabled tests:"
+       for i in ${disabled} ; do
+               [[ -f "${i}" ]] && mv -f "${i}" "${i}.DISABLED" && einfo "Disabled $i"
+       done
+
+       # Avoid the test system removing the results because we want them ourselves
+       sed -e '/^[[:space:]]*$(MAKE) clean/s,^,#,g' \
+               -i "${S}"/t/Makefile
+
+       # Clean old results first
+       cd "${S}/t"
+       git_emake clean
+
+       # Now run the tests
+       cd "${S}"
+       einfo "Start test run"
+       git_emake test
+       rc=$?
+
+       # Display nice results
+       cd "${S}/t"
+       git_emake aggregate-results
+
+       # And exit
+       [ $rc -eq 0 ] || die "tests failed. Please file a bug."
+}
+
+showpkgdeps() {
+       local pkg=$1
+       shift
+       elog "  $(printf "%-17s:" ${pkg}) ${@}"
+}
+
+pkg_postinst() {
+       use emacs && elisp-site-regen
+       use python && python_mod_optimize git_remote_helpers
+       use bash-completion && \
+               einfo "Please read /usr/share/bash-completion/git for Git bash completion"
+       elog "These additional scripts need some dependencies:"
+       echo
+       showpkgdeps git-quiltimport "dev-util/quilt"
+       showpkgdeps git-instaweb \
+               "|| ( www-servers/lighttpd www-servers/apache )"
+       echo
+}
+
+pkg_postrm() {
+       use emacs && elisp-site-regen
+       use python && python_mod_cleanup git_remote_helpers
+}